// @(#)82       1.17  src/rsct/rm/ServiceRM/SfpCl/RmSE.h, ServiceRM, rsct_rrig, rrigt2f3 2/23/03 14:54:39
// IBM_PROLOG_BEGIN_TAG 
// This is an automatically generated prolog. 
//  
//  
//  
// Licensed Materials - Property of IBM 
//  
// Restricted Materials of IBM 
//  
// (C) COPYRIGHT International Business Machines Corp. 2001,2003 
// All Rights Reserved 
//  
// US Government Users Restricted Rights - Use, duplication or 
// disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
//  
// IBM_PROLOG_END_TAG 
#ifndef _RMSE_H
#define _RMSE_H

//*******************************************************************
//
//  RmSE.h is a public header file which'll be included by
//  applications that use either IBM.Sfp or IBM.ServiceEvent.
//
//*******************************************************************


//-------------------------------------------------------
//
//  Return codes for Sfp/SE ClassAction
//
//-------------------------------------------------------

#define SE_SUCCESS              0
#define SE_COMPLETE	            1	// In case of multiple responses, this
					                // will signal the last response.

#define SE_ERROR_RMCDOWN        20	// If there is no connection to the
				                    // local session.

#define SE_ERROR_MTMS_INACTIVE  21	// MTMS is currently inactive.

#define SE_ERROR_INP_INVALID    22	// Invalid input.
#define MSG_ERROR_INP_INVALID   "Invalid input for the class action."

#define SE_ERROR_OPENFILE       23	// Can't open the file to store result
				                    // as in case of transferEEDFile
					                // class action.
#define MSG_ERROR_OPENFILE      "Can't open file as in case of EED, InvScout, or PM file transfer."

#define SE_ERROR_UNKNOWN        24	// Any other errors.
#define MSG_ERROR_UNKNOWN       "Unknown error in the class action."
#define SE_ERROR_MALLOC		    25	// Can't malloc
#define MSG_ERROR_MALLOC	    "Malloc fails!"
#define SE_ERROR_ACTION	        26	// Remote class action fails.
#define MSG_ERROR_ACTION	    "Remote class action fails."

#define SE_ERROR_TRANSFER       27	// Error encountered while
				                    // doing transferEEDFile
#define MSG_ERROR_TRANSFER      "File transfer error encountered. File could be missing, can't be created, or ServiceRM is not running on AIX."

#define SE_SESSION_INACTIVE  	28	// The remote session is not
				                    // established yet!
#define MSG_ERROR_INACTIVE      "There is no active session with the partition. Either it's being deactivated or having a network/hostname setup problem."

#define SE_ERROR_UNSUPPORTED	29	// The class action is not supported
				                    // on the partition.
#define MSG_ERROR_UNSUPPORTED	"The class action is not supported on the system. Please upgrade with appropriate software level."

#define SE_ERROR_INVLDFILE   	30  // Invalid AIX file as in case of PM
					                // or InvScout.
#define MSG_ERROR_INVLDFILE     "Invalid file name."
#define SE_ERROR_WRITE	        31	// Can't write data into file
				                    // as in case of mic download
#define MSG_ERROR_WRITE	        "Can't write data into file %s!"
#define SE_ERROR_SEQUENCE       32	// Data out of sequence as in
				                    // case of mic download
#define MSG_ERROR_SEQUENCE   	"Data out of sequence!"
#define SE_ERROR_FILEATTRS	    33	// Can't change file attributes.
#define MSG_ERROR_FILEATTRS	    "Can't change file attributes (%s %s %s) as requested!"


#define SE_ERROR_PM_UNAVAIL	127
#define MSG_ERROR_PM_UNAVAIL	"PM command fails on the partition. Need to either upgrade AIX or install/upgrade PM on the partition." 

//-------------------------------------------------------
//  ErrorClass definitions for Sfp.set/getEEDCollection
//  class actions.
//-------------------------------------------------------

#define ErrClass_OS	        "OS"
#define ErrClass_HSC		"HSC"
#define ErrClass_CEC		"CEC"
#define ErrClass_SWITCH		"HMC"
#define ErrClass_BPA		"BPA"
#define ErrClass_CSP		"CECCSP"
#define ErrClass_SURV		"SURVALNC"
#define ErrClass_CUOD		"CUOD"


//-------------------------------------------------------
//  Indices/Fields in ServiceEvent's Nodes SD.
//-------------------------------------------------------

#define SIZE_NODES          34
#define ERRORCLASS	         0
#define CECMT		         1
#define CECMS		         2
#define DEVMT		         3
#define DEVMS		         4
#define ERRORCODE	         5
#define ERRORTEXT	         6
#define REPORTINGLOCCODE     7
#define PARTITIONID	         8
#define PARTITIONNAME	     9
#define HOSTNAME	        10
#define OSTYPE		        11
#define ORIGTIMESTAMP		12
#define LASTTIMESTAMP		13
#define ERRLOGRESOURCE		14
#define ERRLOGSEQNUM		15
#define DUPLICATECOUNT		16
#define PTRLOCALEED1		17
#define PTRLOCALEED2		18
#define RESOURCEHANDLE		19
#define CSPTIMESTAMP		20
#define CSPERRORCODE		21
#define CSPERRORTEXT		22
#define CSPLOCCODE	        23
#define CSPINTFRUID	        24
#define CSPPRIORITY	        25
#define CSPLOGDETAIL		26
#define CSPOPPANEL		    27
#define RESERVE_01	        28
#define NLSLOCALES	        RESERVE_01
#define RESERVE_02	        29
#define NLSMSGS		        RESERVE_02
#define RESERVE_03	        30
#define NLSINFO		        RESERVE_03
#define RESERVE_04		    31
#define CLUSTERMTMS	        RESERVE_04
#define FNMNETWORKID        32
#define CREATEDTIMESTAMP    33

//-----------------------------------------------------------
// Field names for each entry in Nodes[]
//
#define NM_ERRORCLASS		"ErrorClass"
#define NM_CECMT		    "CecMT"
#define NM_CECMS	        "CecMS"
#define NM_DEVMT	        "DevMT"
#define NM_DEVMS		    "DevMS"
#define NM_ERRORCODE		"ErrorCode"
#define NM_ERRORTEXT		"ErrorText"
#define NM_REPORTINGLOCCODE	"ReportingLocCode"
#define NM_PARTITIONID		"PartitionId"
#define NM_PARTITIONNAME	"PartitionName"
#define NM_HOSTNAME		    "HostName"
#define NM_OSTYPE	        "OsType"
#define NM_ORIGTIMESTAMP	"OrigTimestamp"
#define NM_LASTTIMESTAMP	"LastTimestamp"
#define NM_ERRLOGRESOURCE	"ErrLogResource"
#define NM_ERRLOGSEQNUM		"ErrLogSeqNum"
#define NM_DUPLICATECOUNT	"DuplicateCount"
#define NM_PTRLOCALEED1		"PtrLocalEED1"
#define NM_PTRLOCALEED2		"PtrLocalEED2"
#define NM_RESOURCEHANDLE	"ResourceHandle"
#define NM_CSPTIMESTAMP		"CSPTimestamp"
#define NM_CSPERRORCODE		"CSPErrorCode"
#define NM_CSPERRORTEXT		"CSPErrorText"
#define NM_CSPLOCCODE		"CSPLocCode"
#define NM_CSPINTFRUID		"CSPIntFRUId"
#define NM_CSPPRIORITY		"CSPPriority"
#define NM_CSPLOGDETAIL		"CSPLogDetail"
#define NM_CSPOPPANEL		"CSPOpPanel"
#define NM_RESERVE_01		"Reserve01"
#define NM_RESERVE_02		"Reserve02"
#define NM_RESERVE_03		"Reserve03"
#define NM_RESERVE_04		"Reserve04"
#define NM_FNMNETWORKID     "FNMNetworkID"
#define NM_CREATEDTIMESTAMP "CreatedTimeStamp"


#define SET_EED_NUM_FIELDS	        4  /* MTM, MS, ErrClass, flag           */
#define GET_EED_NUM_FIELDS	        3  /* MTM, MS, ErrClass                 */

#define SET_CHOME_NUM_FIELDS	    3  /* MTM, MS, activate_flag            */
#define GET_CHOME_NUM_FIELDS	    2  /* MTM, MS		                    */

#define SET_SURV_NUM_FIELDS	        3  /* MTM, MS, activate_flag            */
#define GET_SURV_NUM_FIELDS	        2  /* MTM, MS		                    */

#define SET_SURVNOTIFY_NUM_FIELDS   3  /* MTM, MS, activate_flag            */
#define GET_SURVNOTIFY_NUM_FIELDS   2  /* MTM, MS	                        */

#define SET_SURVTIMERS_NUM_FIELDS   3  /* Connected, Disconnected, Interval */

#define SET_PRUNE_NUM_FIELDS	    2  /* HSC and CEC limits	            */

#define GET_NODESINFO_NUM_FIELDS    2  /* HSC and CEC limits                */


//-----------------------------------------------------------
// For Set/GetServiceInfo class actions.
//  - GetServiceInfo is extended to support InventoryScout
//
#define SETSERVICEINFO_NUM_FIELDS	3
#define SETSERVICEINFO_IN_NUM_FIELDS	SETSERVICEINFO_NUM_FIELDS
#define _IN_SETSE_ID		0
#define _IN_SETSE_ARGS1		1
#define _IN_SETSE_ARGS2		2

#define _OUT_SETSE_RC		0
#define _OUT_SETSE_RCCMD	1
#define _OUT_SETSE_STR1		2
#define _OUT_SETSE_STR2		3


#define GETSERVICEINFO_NUM_FIELDS	3
#define GETSERVICEINFO_IN_NUM_FIELDS	GETSERVICEINFO_NUM_FIELDS
#define _IN_GETSE_ID		0
#define _IN_GETSE_ARGS1		1
#define _IN_GETSE_ARGS2		2

#define    _MIC_DOWNLOAD_MASK   (1<<31)
#define    _PM_GETFILE_MASK     (1<<30)
#define    _SE_SUPPORT_MASKS    (_MIC_DOWNLOAD_MASK|_PM_GETFILE_MASK)
#define GETSERVICEINFO_OUT_NUM_FIELDS	4
#define _OUT_GETSE_RC		0
#define _OUT_GETSE_RCCMD	1
#define _OUT_GETSE_STR1		2
#define _OUT_GETSE_STR2		3

// Valid ID for _IN_GETSE_ID field
//
#define _LOCALE_INFO		1
#define _INVSC_GETVUP		2	// Collect InvScout Files - GA3
#define _INVSC_GETMUP		3
#define _INVSC_GETOTHERS	4
#define _PM_GETFILE	        5	// GA4: Collect PM File
#define _SE_SUPPORT		    6	// GA4: Misc status, support, etc
#define _MIC_DOWNLOAD		7	// GA4: Mic Download
#define _INVSC_CMD	        8	// GA4: update FW
#define _INVSC_GETFILE          9	// GA4: Get any file in
                                        //  directory /var/adm/invscout
#define MAX_SEINFO_ID		9


// Valid ID for SETSE_ID field
//
#define _SETLOCALE_INFO		1
#define _INVSC_PUSHFILE		2
#define _INVSC_RECVFILE		3
#define _SET_SFPDEBUG		4   // Set runtime SfpDebug value 


//-----------------------------------------------------------
// For SetHSCOutOfSync class actions.
//
#define SET_HSCOUTOFSYNC_NUM_FIELDS	3
#define _HSCSYNC_MTM_IN		0
#define _HSCSYNC_MS_IN		1
#define _HSCSYNC_RH_IN		2


//-----------------------------------------------------------
// For SetHMCSwitchOutOfSync class action.
//
#define SET_HMCSWITCHOUTOFSYNC_NUM_FIELDS	4
#define _HMCSWITCH_SOURCEHMC_IN	0
#define _HMCSWITCH_ISMASTER_IN	1
#define _HMCSWITCH_SYNCALL_IN	2
#define _HMCSWITCH_RH_IN	3


#endif // _RMSE_H
